org.eclipse.jetty.util

## Class Utf8Appendable

- java.lang.Object
- - org.eclipse.jetty.util.Utf8Appendable

- Direct Known Subclasses:
    Utf8StringBuffer, Utf8StringBuilder

      public abstract class Utf8Appendable
      extends java.lang.Object

  Utf8 Appendable abstract base class This abstract class wraps a standard `Appendable` and provides methods to append UTF-8 encoded bytes, that are converted into characters. This class is stateful and up to 4 calls to `append(byte)` may be needed before state a character is appended to the string buffer. The UTF-8 decoding is done by this class and no additional buffers or Readers are used. The UTF-8 code was inspired by http://bjoern.hoehrmann.de/utf-8/decoder/dfa/ License information for Bjoern Hoehrmann's code: Copyright (c) 2008-2009 Bjoern Hoehrmann Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Utf8Appendable.NotUtf8Exception`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.Appendable` | `_appendable`
    `protected int` | `_state`
    `static char` | `REPLACEMENT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Utf8Appendable(java.lang.Appendable appendable)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `append(byte b)`
    `void` | `append(byte[] b, int offset, int length)`
    `boolean` | `append(byte[] b, int offset, int length, int maxChars)`
    `protected void` | `appendByte(byte b)`
    `boolean` | `isUtf8SequenceComplete()`
    `abstract int` | `length()`
    `protected void` | `reset()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### REPLACEMENT

          public static final char REPLACEMENT

      See Also:
        Constant Field Values

    - #### _appendable

          protected final java.lang.Appendable _appendable

    - #### _state

          protected int _state

  - ### Constructor Detail

    - #### Utf8Appendable

          public Utf8Appendable(java.lang.Appendable appendable)

  - ### Method Detail

    - #### length

          public abstract int length()

    - #### reset

          protected void reset()

    - #### append

          public void append(byte b)

    - #### append

          public void append(byte[] b,
                    int offset,
                    int length)

    - #### append

          public boolean append(byte[] b,
                       int offset,
                       int length,
                       int maxChars)

    - #### appendByte

          protected void appendByte(byte b)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### isUtf8SequenceComplete

          public boolean isUtf8SequenceComplete()

Copyright © 2013 FuseSource, Corp.. All Rights Reserved.